#include <metal_stdlib>
#include <simd/simd.h>

using namespace metal;

struct Globals
{
    float4x4 uVP;
    float3 uOffset;
    float4 uColor;
};

struct main0_out
{
    float4 gl_Position [[position]];
};

struct main0_in
{
    float3 aPos [[attribute(0)]];
};

vertex main0_out main0(main0_in in [[stage_in]], constant Globals& _24 [[buffer(0)]])
{
    main0_out out = {};
    float3 world = (((in.aPos - float3(0.5)) * 1.0039999485015869140625) + float3(0.5)) + _24.uOffset;
    out.gl_Position = _24.uVP * float4(world, 1.0);
    out.gl_Position.z = (out.gl_Position.z + out.gl_Position.w) * 0.5;
    return out;
}

